#include <stdio.h>
#include <stdlib.h>
#include<string.h>
#include <math.h>
#include <ctype.h>
#define MALLOCRETURN void
#define Malloc(x) mymalloc((long)x)
/* #define Char char  */
/* #define min(X,Y) ((X) < (Y) ? (X) : (Y))
#define max(X,Y) ((X) > (Y) ? (X) : (Y))*/
typedef unsigned char boolean;
/* #define FREE_ARG char* */
#define true    1
#define false   0

MALLOCRETURN  *mymalloc();

typedef enum {Hb,Eb,Tb,Cb,He,Ee,Te,Ce,Ib,Mb,hb,eb,tb,cb,he,ee,te,ce,ib,mb} sstype;

typedef enum {A,R,N,D,C,Q,E,G,H,I,L,K,M,F,P,S,T,W,Y,V} aatype;
typedef double sssite[(short)Mb - (short)Hb+1];
typedef double aasite[(short)V - (short)A+1];
/* typedef unsigned char *dssp; */
typedef int  *dssp;

typedef struct node {
  struct node *next,*back;
  boolean leaf, treename,cond1,cond2,cond3,cond4,aval, simulat;
  short index1;
  aasite **sitevalue;
  char seqname[10];
  double rate;
} node;

typedef struct tree {
  node **pos;
  node *start;
} tree;

int      eof();
int      eoln();
void     memerror();
/*
int xtoy (double x[], double y[], int n)
{ int i; for (i=0; i<n; y[i]=x[i],i++) ;  return(0); }

int matinv( double x[], int n, int m, double space[])
{


   register int i,j,k;
   int *irow=(int*) space;
   double ee=1.0e-20, t,t1,xmax;
   double det=1.0;

   FOR (i,n)  {
      xmax = 0.;
      for (j=i; j<n; j++) {
         if (xmax < fabs(x[j*m+i]))  {
            xmax = fabs( x[j*m+i] );
            irow[i] = j;
         }
      }
      det *= xmax;
      if (xmax < ee)   {
         printf("\nDet becomes zero at %3d!\t\n", i+1);
         return(-1);
      }
      if (irow[i] != i) {
         FOR (j,m) {
            t = x[i*m+j];
            x[i*m+j] = x[irow[i] * m + j];
            x[ irow[i] * m + j] = t;
         }
      }
      t = 1./x[i*m+i];
      FOR (j,n) {
         if (j == i) continue;
         t1 = t*x[j*m+i];
         FOR(k,m)  x[j*m+k] -= t1*x[i*m+k];
         x[j*m+i] = -t1;
      }
      FOR(j,m)   x[i*m+j] *= t;
      x[i*m+i] = t;
   }                            
   for (i=n-1; i>=0; i--) {
      if (irow[i] == i) continue;
      FOR(j,n)  {
         t = x[j*m+i];
         x[j*m+i] = x[ j*m + irow[i] ];
         x[ j*m + irow[i] ] = t;
      }
   }
   return (0);
}

*/


input_reset();
input_redraw();
input_resume();
input_save(char * file);
input_load(char * file);
extern double log();
extern double exp();

void recyclingbay();
void loadingbay();
void storagebay();
double calc_like(node *,tree *);
void leaf2root(node *,tree *);
double usrsec2(node *);
double rtsec2(node*,double,double);
/* void calc_em(node*,double);*/
/* set_false
   set_true */
/* output(node*,boolean);*/
void prediction();
/* void output2(node*,boolean);*/
void find1(char *);
/* void find2(char,short *,short *); */
void read_length(node*);
/* void leaf_add(node *,short *,short *,boolean *);*/
void leaf_add(node *,short *,short *);
void use_tree();
void Qmatrix();
void Rfind();
void star();
/* result(boolean);*/
void walkinforest();
double *dvector(long nl, long nh);
double **dmatrix(long nrl, long nrh, long ncl, long nch);
void free_dvector(double *v, long nl, long nh);
void free_dmatrix(double **m, long nrl, long nrh, long ncl, long nch);
void nrerror(char error_text[]);
int *ivector(long nl, long nh);
void free_ivector(int *i,long nl, long nh);
struct _input {
char name[280];
void *addr;
int type;  /* 'i', 'd', 's' */
} linput[50];
int iinput = 0;
input_reset()
{ iinput = 0; }
input_insert(name, addr, type)
char *name;
void *addr;
int type;
{
	strcpy(linput[iinput].name, name);
	linput[iinput].addr = addr;
	linput[iinput].type = type;
	iinput ++; }
input_redraw()
{
	int i;
	printf("\n");
	for (i=0; i<iinput; i++) {
		printf("%c) %s: ", 'a'+i, linput[i].name);
		switch(linput[i].type){
			case 'i':
				printf("%d\n", * ((int *) linput[i].addr));
				break;
			case 'd':
				printf("%lf\n", *((double *) linput[i].addr));
				break;
			case 's':
				printf("%s\n", (char *) linput[i].addr);
				break;}	} }
/* ******************** */
input_resume()
{
	int i;
	for (i=0; i<iinput; i++) {
		printf("%c) %s: \t", 'a'+i, linput[i].name);
	switch(linput[i].type){
			case 'i':
				printf("%d\n", * ((int *) linput[i].addr));
				break;
			case 'd':
				printf("%lf\n", *((double *) linput[i].addr));
				break;
			case 's':
				printf("%s\n", (char *) linput[i].addr);
				break;}	}}
/* ******************* */
input_save(char * file)
{
	int i;
	FILE *f;
	f = fopen(file, "w");
	for (i=0; i<iinput; i++) {
		switch(linput[i].type){
			case 'i':
				fprintf(f,"%d\n", * ((int *) linput[i].addr));
				break;
			case 'd':
				fprintf(f,"%lf\n", *((double *) linput[i].addr));
				break;
			case 's':
				fprintf(f,"%s\n", (char *) linput[i].addr);
				break;	} }
	fclose(f); }
/* ********************** */
input_load(char * file)
{
	int i;
	FILE *f;
	char s[300];
	f = fopen(file, "r");
	if (f==NULL) return(-1);
	for (i=0; i<iinput; i++) {
		fgets(s,80, f);
		switch(linput[i].type){
			case 'i':
				sscanf(s,"%d", (int *) linput[i].addr);
				break;
			case 'd':
				sscanf(s,"%lf", (double *) linput[i].addr);
				break;
			case 's':
				sscanf(s,"%s\n", (char *) linput[i].addr);
				break; 	}}
	fclose(f); }
/* ****************** */
input()
{
	int i, c;
	int flag=1;
	char s[200];
	input_redraw();
	printf("\nchoose a letter (. to accept) :> ");
	for (;;) {
		c=getchar();
		if (isupper(c)) c = tolower(c);
		if (c == '.') return 0;
		i = c - 'a';
		if (i < iinput && i >= 0) {
			printf("\n%s: ",linput[i].name);
			switch(linput[i].type){
				case 'i':
					scanf("%d", (int *) linput[i].addr);
					break;
				case 'd':
					scanf("%lf", (double *) linput[i].addr);
					break;
				case 's':
					scanf("%s", (char *) linput[i].addr);
					break;
				default:
					break; 	}
			input_redraw();
			printf("\nchoose a letter (. to accept) :> ");}}}
/* ***************** */
int eof(f)
FILE *f;
{ register int ch;
    if (feof(f)) return 1;
    if (f == stdin) return 0;
    ch = getc(f);
    if (ch == EOF) return 1;
    ungetc(ch, f);
    return 0;}
/* ****************** */
int eoln(f)
FILE *f;
{   register int ch;
    ch = getc(f);
    if (ch == EOF) return 1;
    ungetc(ch, f);
    return (ch == '\n'); }
/* ********************************* */    
void memerror(){     /* alternative at nrerror */
printf("Error allocating memory\n");
exit(-1); } 
/* ********************************* */
MALLOCRETURN *mymalloc(x)
long  x;
{MALLOCRETURN *mem;
mem = (MALLOCRETURN *)calloc(1,x);
if (!mem) memerror();
else return (MALLOCRETURN *)mem; }
/* ********************************* */
void uppercase(ch)
char *ch;
{ *ch = isupper(*ch) ? *ch : toupper(*ch);}
/* ********************************** */
void test(ch,j,i)
char ch;
short i, j;
{ if (strchr("ACDEFGHIKLMNPQRSTVWXY?J-",ch) == NULL){
printf("\n ERROR: BAD AMINOACID at position %d sequence %d \n",j,i);
exit(-1); }}
/* *********************************** */
void link(node1, node2)
node *node1, *node2;
{ node1->back = node2;
  node2->back = node1; }
/* ************************************ */
void nrerror(char error_text[]) {
        fprintf(stderr,"something wrong...\n");
        fprintf(stderr,"%s\n",error_text);
        fprintf(stderr,"...now exiting to system...\n");
        exit(1); }
/* ************************************************************ */
unsigned char *cvector(long nl, long nh) {unsigned char *v;
        v=(unsigned char *)malloc((size_t) ((nh-nl+1+1)*sizeof(unsigned char)));
        if (!v) nrerror("allocation failure in cvector()");
        return v-nl+1; }
/* ************************************************************ */
char *ccvector(long nl, long nh) {
        char *v;
        v=(char *)malloc((size_t) ((nh-nl+1+1)*sizeof(char)));
        if (!v) nrerror("allocation failure in cvector()");
        return v-nl+1; }
/* ******************************************************** */
int *ivector(long nl, long nh) {
        int *v;
        v=(int *)malloc((size_t) ((nh-nl+1+1)*sizeof(int)));
        if (!v) nrerror("allocation failure in ivector()");
        return v-nl+1; }
/* ******************************************************* */
double *dvector(long nl, long nh) {
        double *v;
        v=(double *)malloc((size_t) ((nh-nl+1+1)*sizeof(double)));
        if (!v) nrerror("allocation failure in dvector()");
        return v-nl+1; }
/* ******************************************************** */
double **dmatrix(long nrl, long nrh, long ncl, long nch)
{
        long i, nrow=nrh-nrl+1,ncol=nch-ncl+1;
        double **m;
        m=(double **) malloc((size_t)((nrow+1)*sizeof(double*)));
        if (!m) nrerror("allocation failure 1 in matrix()");
        m += 1;
        m -= nrl;
        m[nrl]=(double *) malloc((size_t)((nrow*ncol+1)*sizeof(double)));
        if (!m[nrl]) nrerror("allocation failure 2 in matrix()");
        m[nrl] += 1;
        m[nrl] -= ncl;
        for(i=nrl+1;i<=nrh;i++) m[i]=m[i-1]+ncol;
        return m; }
/* ******************************************************** */
char **cdmatrix(long nrl, long nrh, long ncl, long nch)
{
        long i, nrow=nrh-nrl+1,ncol=nch-ncl+1;
        char **m;
        m=(char **) malloc((size_t)((nrow+1)*sizeof(char*)));
        if (!m) nrerror("allocation failure 1 in matrix()");
        m += 1;
        m -= nrl;
        m[nrl]=(char *) malloc((size_t)((nrow*ncol+1)*sizeof(char)));
        if (!m[nrl]) nrerror("allocation failure 2 in matrix()");
        m[nrl] += 1;
        m[nrl] -= ncl;
        for(i=nrl+1;i<=nrh;i++) m[i]=m[i-1]+ncol;
        return m; }
/* ******************************************************* */
int **imatrix(long nrl, long nrh, long ncl, long nch)
{
        long i, nrow=nrh-nrl+1,ncol=nch-ncl+1;
        int **m;
        m=(int **) malloc((size_t)((nrow+1)*sizeof(int*)));
        if (!m) nrerror("allocation failure 1 in matrix()");
        m += 1;
        m -= nrl;
        m[nrl]=(int *) malloc((size_t)((nrow*ncol+1)*sizeof(int)));
        if (!m[nrl]) nrerror("allocation failure 2 in matrix()");
        m[nrl] += 1;
        m[nrl] -= ncl;
        for(i=nrl+1;i<=nrh;i++) m[i]=m[i-1]+ncol;
        return m; }
/* *********************************************************** */
int ***itmat(dim3,nrow,ncol)
int nrow,ncol,dim3;
{  int ***m;
   int nrl,ncl;
m =(int ***) malloc((unsigned) (dim3+1)*sizeof(int**));
if (!m) nrerror("allocation failure");
for(nrl=0; nrl<= dim3; nrl++) {
   m[nrl]=(int **) malloc((unsigned)(nrow+1)*sizeof(int*));
if (!m[nrl]) nrerror("allocation failure");
for(ncl=0;ncl<=nrow;ncl++) {
m[nrl][ncl] = (int *) malloc((unsigned)(ncol+1)*sizeof(int));
  if (!m[nrl][ncl]) nrerror("allocation failure");}}
   return m;}
/* ****************************************************************** */
double ***d3matrix(dim3,nrow,ncol)
int dim3,nrow,ncol;
{  double ***m; 
   int nrl,ncl;
   m =(double ***) malloc((unsigned) (dim3+1)*sizeof(double**));
if (!m) nrerror("allocation failure");
for(nrl=0; nrl<= dim3; nrl++) {
   m[nrl]=(double **) malloc((unsigned)(nrow+1)*sizeof(double*));
if (!m[nrl]) nrerror("allocation failure");
for(ncl=0;ncl<=nrow;ncl++) {
m[nrl][ncl] = (double *) malloc((unsigned)(ncol+1)*sizeof(double));
         if (!m[nrl][ncl]) nrerror("allocation failure"); } }
   return m; }
/* ******************************************************* */
void free_ivector(int *v, long nl, long nh)
{  free((char*) (v+nl-1));   }
/* **************************************************** */
void free_cvector(unsigned char *v, long nl, long nh) {
        free((char*) (v+nl-1));}
/* **************************************************** */
void free_ccvector(char *v, long nl, long nh) {
        free((char*) (v+nl-1));}
/* ******************************************************* */
void free_tmat(m, dim3,nrow, ncol)
int ***m;
int dim3, nrow, ncol;
{  int nrl,ncl;
   for(nrl=dim3;nrl>=0;nrl--) {
      for(ncl=nrow;ncl>=0;ncl--) free((char*)
         (m[nrl][ncl]));
      free((char*) (m[nrl])); }
   free((char*) (m)); }
/* ****************************************************** */
void free_dvector(double *v, long nl, long nh) {
        free((char*) (v+nl-1));}
/* **************************************************  */
void free_dmatrix(double **m, long nrl, long nrh, long ncl, long nch)
{free((char*) (m[nrl]+ncl-1));
free((char*) (m+nrl-1));}
/* **************************************************** */
void free_imatrix(int **m, long nrl, long nrh, long ncl, long nch)
{free((char*) (m[nrl]+ncl-1));
free((char*) (m+nrl-1));}
/* **************************************************** */
void free_cmatrix(char **m, long nrl, long nrh, long ncl, long nch)
{free((char*) (m[nrl]+ncl-1));
free((char*) (m+nrl-1));}
/* ****************************************** */
void free_d3matrix(m, dim3,nrow, ncol)
double ***m;
int nrow, ncol, dim3;
{ int nrl,ncl;
for(nrl=dim3;nrl>=0;nrl--){
      for(ncl=nrow;ncl>=0;ncl--) free((char*)
         (m[nrl][ncl]));
   free((char*) (m[nrl]));}
   free((char*) (m));}
/* ******************************************** */
